## AUTHOR      :: UMESH CHAUHAN || ROR CONSULTANT & DEPLOYMENT OF LINUX(HOSTGATOR)
## HISTORY     :: 1.0.0
## DESCRIPTION :: This module control all sale process integration for main controller
class SaleInsightController < ApplicationController
   before_action :require_login
   before_action :allowed_pages
   before_action :is_allowed_location
   skip_before_action :verify_authenticity_token,:only=>[:ajax_process,:index]
   include ErpModule::Common
   helper_method :financial_session_date,:last_financial_session_date,:currency_formatted,:set_ent,:set_dct
   helper_method :year_month_days_formatted,:formatted_date,:get_all_selected_customer_bills,:get_as_on_months
   helper_method :total_monthwise_dueamounts,:greaterthan_sixmonth_dueamounts

 def index
     @compcodes        =  session[:loggedUserCompCode]
     @tseach           =  ''
     @OrdPrint         =  nil
     @InvTypes         =  nil
     @finayear         =  financial_session_date
     @lastfinyear      =  last_financial_session_date
     month_number      =  Time.now
     begdate           =  Date.parse(month_number.to_s)
     @nbegindate       =  begdate.strftime('%Y')     
     @nmonthdate1      =  begdate.strftime('%m')
     @AvrgMSale        =  0
     monthnumber       =  month_number.month
     monthbegin        =  Date.new(Date.today.year, monthnumber)
     nbegdate          =  Date.parse(monthbegin.to_s)
     @nbegindate       =  nbegdate.strftime('%Y-%m-%d')
     if params[:invtype]!=nil && params[:invtype]!='' && params[:invtype] =='L'
         @TotalSale     = sale_total_financial()
         @TotalRcv      = receive_total_financial('','','')
         @TotalOverDue  = overdue_atthis_financial()
         @TotalCurSale  = current_sale_detail()
         @TotalLastSale = last_sale_detail();
         @TotalOutStand = ( @TotalSale.length >0 ? @TotalSale[0].totalAmount : 0 ).to_f-( @TotalRcv.length >0 ? @TotalRcv[0].totalPayReceive : 0 ).to_f
         @CustomerDtl   = get_customers_received_detail()
         @PaymentDtl    = get_recived_payment()
         @Grhchart      = get_chart_month_wise()
         @Tnmaxval      = maximum_revenue_charts()
         $GlTYPE        = 'L'
     else

       @InvTypes      ='E'
       @TotalSale     = export_total_financial()
       @TotalRcv      = receive_total_financial('','','')
       @TotalOverDue  = export_overdue_atthis_financial()
       @TotalCurSale  = current_export_detail()
       @TotalLastSale = last_export_detail();
       @TotalOutStand = get_total_outsatnding #( @TotalSale.length >0 ? @TotalSale[0].totalAmount : 0 ).to_f-( @TotalRcv.length >0 ? @TotalRcv[0].totalPayReceive : 0 ).to_f
       @CustomerDtl   = get_export_customers_received()
       @PaymentDtl    = get_export_recived_payment()
       @Grhchart      = get_export_chart_month_wise()
       @GchartOutM    = chart_total_outsatnding()
       @Tnmaxval      = export_maximum_revenue_charts()
       @AvrgMSale     = average_monthly_export_sale()
       @AvrgMRecv     = average_received_amount()
       @DueAsonDate   = as_on_duedays_total()
       $GlTYPE        = @InvTypes

     end
    # update_process_customer()
     
end
def update_process_customer
     customerobj  =   MstCustomer.where("cs_compcode = ? AND cs_customername<>''",@compcodes).order("cs_customername ASC")
     if customerobj.length >0
           customerobj.each do |customobj|
             tpamtent = customer_total_payment(customobj.id)
             saleinv  = customer_total_invoice(customobj.id)
             cbs = saleinv.to_f-tpamtent.to_f
            find_process_customer(customobj.id,cbs)
           end
     end
end

def find_process_customer(custid,cbs)
      custobj =  MstCustomer.where("cs_compcode = ? and id=?",@compcodes,custid).first
      if custobj
          obal   = custobj.cs_yobamount
          newcbs = cbs.to_f+obal.to_f
          custobj.update(:cs_cbamount=>newcbs)
      end
end
def customer_total_payment(customers)
   tpaymt = 0
   @MstReceive    =  MstPaymentReceive.select("SUM(pr_netamount) as totalpayment").where("pr_compcode = ? AND pr_customer_id =?",@compcodes,customers).first
   if @MstReceive
     tpaymt = @MstReceive.totalpayment
   end
   return tpaymt
end

def customer_total_invoice(customers)
   tpaymt = 0
   jons = "INNER JOIN trn_packing_invoice_details trn ON(pldi_compcode=pli_compcode AND pldi_sale_type=pli_sale_type AND pldi_number=pli_number AND pldi_locality_type=pli_local_type)"
   trninvobj = TrnPackingInvoice.select("SUM(pldi_net_amt) as totalpayment").joins(jons).where("pli_compcode = ? AND pli_invoice_to_id = ?",@compcodes,customers).first
   if trninvobj
     tpaymt = trninvobj.totalpayment
   end
   return tpaymt
end

def saleinsight_refresh
 session[:request_params] = nil
 session.delete(:request_params)
 redirect_to "#{root_url}"+"sale_insight"
end

def show
   @compcodes  = session[:loggedUserCompCode]
   if  session[:xlxs_order]!=nil && session[:xlxs_order]!='' && session[:xlxs_order] == 'Y'
        if $GlTYPE =='E'
           custobj = export_print_customers_received_detail
        else
           custobj = print_customers_received_detail
        end       
        if custobj.length >0
             @isexcel       = custobj
             $compcodes     = @compcodes
             $STARTFINAYEAR = financial_session_date
             $ENDFINALYEAR  = last_financial_session_date
             send_data @isexcel.to_order_details, :filename=>"customer-details-#{Date.today}.csv"
        end
    elsif  session[:xlxs_order]!=nil && session[:xlxs_order]!='' && session[:xlxs_order] == 'PY'
      if $GlTYPE =='E'        
           payobj = export_print_recived_payment
        else
           payobj = print_recived_payment
        end
       
        if payobj.length >0
             @isexcel       = payobj
             $compcodes     = @compcodes
             $STARTFINAYEAR = financial_session_date
             $ENDFINALYEAR  = last_financial_session_date             
            send_data @isexcel.to_payment_details, :filename=>"custpayment-details-#{Date.today}.csv"
        end
    end
end

def ajax_process
  isstatus = false
  if params[:isprintcustomer]!=nil && params[:isprintcustomer]!='' && params[:isprintcustomer] =='CUSTPRT'
      if params[:rpt] == 'Y'
        session[:xlxs_order] = 'Y'
        isstatus = true
      elsif  params[:rpt] == 'PY'
        session[:xlxs_order] = 'PY'
        isstatus = true
      end
      respond_to do |format|
      format.json { render :json => { 'data'=>'', "message"=>'',:status=>isstatus } }
     end
     return
  end
  
 
end
private
def get_total_outsatnding
  totinv     = 0  
  isselect   = "SUM(pli_balan_amount) as totalinvoice"
  totinvobj  =  TrnPackingInvoice.select(isselect).where("pli_compcode = ? AND DATE(NOW()) >=DATE(pli_due_date) AND pli_status<>'C'",@compcodes).first
  if totinvobj
    totinv = totinvobj.totalinvoice
  end
  return totinv

end

private
def chart_total_outsatnding
  totinv     = 0
  isselect   = "SUM(pli_balan_amount) as totalinvoice"
  totinvobj  =  TrnPackingInvoice.select(isselect).where("pli_compcode = ? AND DATE(NOW()) >=DATE(pli_due_date) AND pli_status<>'C'",@compcodes).group("MONTH(pli_date)").order("pli_balan_amount DESC").first
  if totinvobj
    totinv = totinvobj.totalinvoice
  end
  return totinv

end
private
def receive_total_financial(ptype,smonth,syear)
   finayear     = financial_session_date
   lastfinyear  = last_financial_session_date
    iswhere = "pr_compcode = '#{@compcodes}' " #AND DATE(pr_date) >='#{finayear}' AND DATE(pr_date) <='#{lastfinyear}'
    if smonth!=nil && smonth!=''
     iswhere += " AND MONTH(pr_date) ='#{smonth}'"
    end
    if syear!=nil && syear!=''
      iswhere += " AND YEAR(pr_date) ='#{syear}'"
    end
    if ptype!=nil && ptype!=''
      iswhere += " AND pr_doctype ='#{ptype}'"
    end
    isselect    = "COALESCE(sum(pr_netamount),0) as totalPayReceive"
    
    receiveobj  = MstPaymentReceive.select(isselect).where(iswhere)
  return receiveobj
end

private
def sale_total_financial
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect = "sum(hd_total_amount) as totalAmount"
  iswhere  = " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND hd_status!='C'"
 # iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}'"
  saleobj   = TrnHdr.select(isselect).where(iswhere)
  return saleobj
  
end

private
def current_sale_detail
  isselect = "sum(hd_total_amount) as totalAmount"
  iswhere  = " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND hd_status!='C'"
  iswhere  += " AND DATE(hd_billdate) = CURDATE() AND YEAR(hd_billdate) = YEAR(CURRENT_DATE())"
  saleobj   = TrnHdr.select(isselect).where(iswhere)
  return saleobj

end

private
def last_sale_detail
  isselect =  "sum(hd_total_amount) as totalAmount"
  iswhere  =  " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND hd_status!='C'"
  iswhere  += " AND  MONTH(hd_billdate) = MONTH((CURRENT_DATE - INTERVAL 1 MONTH)) AND YEAR(hd_billdate) = YEAR(CURRENT_DATE())"
  saleobj  =  TrnHdr.select(isselect).where(iswhere)
  return saleobj

end

private
def overdue_atthis_financial
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  " sum(hd_total_amount) as totalAmount,cst.id as cstId"
  iswhere  =  " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND DATE(CURRENT_DATE()) > DATE_ADD(hd_billdate,INTERVAL (hd_creditdays+cs_creditdays) DAY) AND hd_creditdays >0 AND hd_status!='C'"
  # iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}' "
  jons     =  "JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  saleobj  =  TrnHdr.select(isselect).joins(jons).where(iswhere)
  return saleobj
  
end

private
def get_customers_received_detail
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "sum(hd_total_amount) as totalAmount,cst.id as CstId,cs_customername,cs_emailaddress,sum(hd_total_value) as totalvalue"
  isselect +=  ",'' as lastdate,'' as totaldueamt,hd_customer_id,COUNT(*) as totalInvoice"
  jons     =  "JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  iswhere  =  " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND hd_status!='C'"
  #iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}'"
  saleobj  =  TrnHdr.select(isselect).joins(jons).where(iswhere).group("hd_customer_id")
  arr      = []
   if saleobj.length >0
         saleobj.each do |rcv|
              lastobj = get_last_payment(rcv.hd_customer_id)
             # recvobj = get_recived_amount(rcv.hd_customer_id)
              if lastobj
                rcv.lastdate = lastobj.lastdate
              end
              rcv.totaldueamt = rcv.totalAmount.to_f
              
              arr.push rcv
         end
         
         printcontrol =  "1_customer_report"
         @OrdPrint    =  sale_insight_path(printcontrol,:format=>"pdf")
   end
  return arr
end

private
def get_last_payment(customers)
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect     = " DATE_FORMAT(pr_date,'%d-%b-%Y') as lastdate"
  iswhere      = "pr_compcode = '#{@compcodes}' AND DATE(pr_date) >='#{finayear}' AND DATE(pr_date) <='#{lastfinyear}'"
  iswhere      += " AND pr_customer_id='#{customers}' AND pr_status<>'C'"
  receiveobj   = MstPaymentReceive.select(isselect).where(iswhere).order("pr_date DESC").first
  return receiveobj
end


private
def average_received_amount()
  totalrecev   = 0
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect     = " COALESCE(sum(pr_netamount),0) as totalPayReceive"
  iswhere      = "pr_compcode = '#{@compcodes}' AND DATE(pr_date) >='#{finayear}' AND DATE(pr_date) <='#{lastfinyear}'"
  iswhere      += " AND pr_status<>'C'"
  receiveobj   = MstPaymentReceive.select(isselect).where(iswhere).first
  if receiveobj
    totalrecev = receiveobj.totalPayReceive
  end
  if totalrecev.to_f >0
     months     = count_average_month()
     totalrecev = totalrecev.to_f/months.to_i
  end
  return totalrecev
end

private
def count_average_month()
  
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect     = " COUNT(*) as months"
  iswhere      = "pr_compcode = '#{@compcodes}' AND DATE(pr_date) >='#{finayear}' AND DATE(pr_date) <='#{lastfinyear}'"
  iswhere      += " AND pr_status<>'C'"
  receiveobj   = MstPaymentReceive.select(isselect).where(iswhere).group("MONTH(pr_date)")
  mnths        = 0
  if receiveobj.length >0
     receiveobj.each do |cnts|
       mnths +=1
     end
    
  end 
  return mnths
end

private
def get_recived_amount(customers)
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect     = " COALESCE(sum(pr_netamount),0) as totalPayReceive"
  iswhere      = "pr_compcode = '#{@compcodes}' AND DATE(pr_date) >='#{finayear}' AND DATE(pr_date) <='#{lastfinyear}'"
  iswhere      += " AND pr_customer_id='#{customers}' AND pr_status<>'C'"
  receiveobj   = MstPaymentReceive.select(isselect).where(iswhere).group("pr_customer_id")
  return receiveobj
end

private
def get_recived_payment
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "sum(hd_total_amount) as totalAmount,cst.id as CstId,cs_customername,sum(hd_total_value) as totalvalue"
  isselect +=  ",'' as totalReceive,'' as dueamount,hd_customer_id,'' as pendingamnt"
  jons     =  "JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  iswhere  =  " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND hd_status!='C' "
 # iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}'"
  saleobj  =  TrnHdr.select(isselect).joins(jons).where(iswhere).group("hd_customer_id")
  arr      = []
   if saleobj.length >0
         saleobj.each do |rcv|
              rcv.dueamount  = rcv.totalAmount.to_f
              recvobj = get_recived_amount(rcv.hd_customer_id)             
              if recvobj.length >0
                rcv.pendingamnt = rcv.totalAmount.to_f-recvobj[0].totalPayReceive.to_f
                rcv.totalReceive = recvobj[0].totalPayReceive.to_f                
              else
               rcv.pendingamnt = rcv.totalAmount.to_f
               rcv.totalReceive = 0
              end
              arr.push rcv
         end
         printcontrol =  "1_payment_report"
         @PayPrint    =  sale_insight_path(printcontrol,:format=>"pdf")

   end
  return arr
end


private
def get_chart_month_wise
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "sum(hd_total_amount) as totalAmount,cst.id as CstId,cs_customername,sum(hd_total_value) as totalvalue,MONTH(hd_billdate) as month"
  isselect +=  ",'' as totalReceive,'' as dueamount,hd_customer_id,'' as pendingamnt,'' as overdueamt,hd_sale_type as sale,hd_paymentmode"
  jons     =  "JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  iswhere  =  " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND hd_status!='C' "
  #iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}'"
  saleobj  =  TrnHdr.select(isselect).joins(jons).where(iswhere).group("MONTH(hd_billdate)")
  arr      = []
   if saleobj.length >0
         saleobj.each do |rcv|
              rcv.dueamount  = rcv.totalAmount.to_f
              recvobj  =  get_recived_amount(rcv.hd_customer_id)
              ovdueobl =  get_customer_overdue(rcv.hd_customer_id)
              if recvobj.length >0
                rcv.pendingamnt = rcv.totalAmount.to_f-recvobj[0].totalPayReceive.to_f
               # rcv.totalReceive = recvobj[0].totalPayReceive.to_f
              else
               rcv.pendingamnt  = rcv.totalAmount.to_f
               #rcv.totalReceive = 0
              end
              if ovdueobl.length >0
                rcv.overdueamt = ovdueobl[0].totalAmount
              end
              arr.push rcv
         end
   end
  return arr
end

private
def get_customer_overdue(customers)
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  " sum(hd_total_amount) as totalAmount,cst.id as cstId"
  iswhere  =  " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND DATE(CURRENT_DATE()) > DATE_ADD(hd_billdate,INTERVAL (hd_creditdays+cs_creditdays) DAY)"
 # iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}' "
  iswhere  += " AND hd_customer_id='#{customers}' AND hd_creditdays >0 AND hd_status!='C'"
  jons     =  "JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  saleobj  =  TrnHdr.select(isselect).joins(jons).where(iswhere).group("MONTH(hd_billdate)")
  return saleobj

end

private
def maximum_revenue_charts
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  gxorders     = " (CASE
                WHEN hd_sale_type ='SL' THEN 'S'
                WHEN hd_sale_type ='SO' THEN 'S'
                WHEN hd_sale_type ='SO' THEN 'S'
                ELSE hd_sale_type
                END),MONTH(hd_billdate)"
  iswhere  =  " hd_compcode='#{@compcodes}' AND hd_creditdays >0 AND hd_status!='C'"
 # iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}' "
  isselect = " COALESCE(sum(hd_total_amount),0) as totalsale,MONTH(hd_billdate) as month,hd_sale_type as sale"
  tcharts  = TrnHdr.select(isselect).where(iswhere).group(gxorders).order('SUM(hd_total_amount) DESC').first
 return tcharts
 
end
private
def print_customers_received_detail
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "sum(hd_total_amount) as totalAmount,cst.id as CstId,cs_customername,sum(hd_total_value) as totalvalue"
  isselect +=  ",'' as lastdate,'' as totaldueamt,hd_customer_id,hd_paymentmode,'' as overdueamt"
  jons     =  "JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  iswhere  =  " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND hd_status!='C'"
 # iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}'"
  saleobj  =  TrnHdr.select(isselect).joins(jons).where(iswhere).group("hd_customer_id")  
  return saleobj
end

private
def print_recived_payment
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "sum(hd_total_amount) as totalAmount,cst.id as CstId,cs_customername,sum(hd_total_value) as totalvalue"
  isselect +=  ",'0' as totalReceive,'' as dueamount,hd_customer_id,'' as pendingamnt,hd_paymentmode"
  jons     =  "JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  iswhere  =  " hd_compcode='#{@compcodes}'  AND hd_sale_type IN('S','SO','SL') AND hd_status!='C' "
 # iswhere  += " AND DATE(hd_billdate) >= '#{finayear}' AND DATE(hd_billdate) <= '#{lastfinyear}'"
  saleobj  =  TrnHdr.select(isselect).joins(jons).where(iswhere).group("hd_customer_id")    
  return saleobj
end


###### SATRT EXPORT INVOICE CALCULATION#############


private
def export_total_financial
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect = "sum(pli_balan_amount) as totalAmount"
  iswhere  = " pli_compcode='#{@compcodes}' AND pli_sale_type IN('S') AND pli_local_type='Export' AND pli_status<>'C'"
 # iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}'"
  saleobj   = TrnPackingInvoice.select(isselect).where(iswhere)
  return saleobj

end

private
def current_export_detail
  isselect = "sum(pli_net_amount) as totalAmount"
  iswhere  = " pli_compcode='#{@compcodes}'  AND pli_sale_type IN('S') AND pli_local_type='Export' AND pli_status<>'C'"
  iswhere  += " AND MONTH(pli_date) = MONTH(CURDATE()) AND YEAR(pli_date) = YEAR(CURRENT_DATE())"
  saleobj   = TrnPackingInvoice.select(isselect).where(iswhere)
  return saleobj

end

private
def last_export_detail
  isselect =  "sum(pli_net_amount) as totalAmount"
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_sale_type IN('S') AND pli_local_type='Export' AND pli_status<>'C'"
  iswhere  += " AND  MONTH(pli_date) = MONTH((CURRENT_DATE - INTERVAL 1 MONTH)) AND YEAR(pli_date) = YEAR(CURRENT_DATE())"
  saleobj  =  TrnPackingInvoice.select(isselect).where(iswhere)
  return saleobj

end

private
def export_overdue_atthis_financial
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  " sum(pli_net_amount) as totalAmount,cst.id as cstId"
  iswhere  =  " pli_compcode='#{@compcodes}'  AND pli_sale_type IN('S') AND DATE(CURRENT_DATE()) > DATE_ADD(pli_date,INTERVAL cs_creditdays DAY) AND cs_creditdays >0 AND pli_local_type='Export' AND pli_status<>'C'"
  #iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}' "
  jons     =  "JOIN mst_customers cst ON(cst.id=pli_invoice_to_id AND cst.cs_compcode=pli_compcode)"
  saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere)
  return saleobj

end



private
def get_export_customers_received
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "SUM(pli_net_amount) as totalAmount,cst.id as CstId,cs_customername,cs_emailaddress,sum(pli_total_amount) as totalvalue"
  isselect +=  ",'' as lastdate,'' as totaldueamt,pli_invoice_to_id as hd_customer_id,COUNT(pli_invoice_to_id) as totalInvoice"
  isselect +=  ", SUM(pli_credit_days) as creditDays "
  isselect   += " ,( CASE WHEN DATE(NOW()) >=DATE(pli_due_date) THEN 'Y' ELSE 'N' END) as duepends"
  jons     =  " LEFT JOIN mst_customers cst ON(cst.id=pli_invoice_to_id AND cst.cs_compcode=pli_compcode)"
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_sale_type IN('S') AND pli_local_type='Export' AND pli_status<>'C' and pli_balan_amount >0"
 # iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}'"
  saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere).group("pli_invoice_to_id")
  arr      = []
   if saleobj.length >0
         saleobj.each do |rcv|
              lastobj = get_export_last_payment(rcv.hd_customer_id)
              if lastobj
                rcv.lastdate = lastobj.lastdate
              end
              dueamt = get_customerwise_totaloutsatnding(rcv.hd_customer_id)
              rcv.totaldueamt = dueamt # rcv.totalAmount.to_f
              #totainv =  total_sale_siteinvoiceamount(rcv.hd_customer_id)
              #rcv.totalAmount = totainv
              arr.push rcv
         end

         printcontrol =  "1_customer_report"
         @OrdPrint    =  sale_insight_path(printcontrol,:format=>"pdf")
   end
  return arr
end

private
def total_sale_siteinvoiceamount(customers)
  amts = 0
  isselect = "SUM(pldi_net_amt) as netamt "
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_sale_type IN('S') AND pli_local_type='Export' AND pli_status<>'C' AND pli_invoice_to_id='#{customers}'"
  jons = "INNER JOIN trn_packing_invoice_details trn ON(pldi_compcode=pli_compcode AND pldi_sale_type=pli_sale_type AND pldi_number=pli_number AND pldi_locality_type=pli_local_type)"
  saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere).first
  if saleobj
    amts = saleobj.netamt
  end
  return amts
end

private
def get_export_last_payment(customers)
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect     = " DATE_FORMAT(pr_date,'%d-%b-%Y') as lastdate"
  iswhere      = "pr_compcode = '#{@compcodes}' " #AND DATE(pr_date) >='#{finayear}' AND DATE(pr_date) <='#{lastfinyear}'
  iswhere      += " AND pr_customer_id='#{customers}' AND pr_status<>'C'"
  receiveobj   = MstPaymentReceive.select(isselect).where(iswhere).order("pr_date DESC").first
  return receiveobj
end

private
def get_export_recived_amount(customers)
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect     = " COALESCE(sum(pr_netamount),0) as totalPayReceive"
  iswhere      = "pr_compcode = '#{@compcodes}' " #AND DATE(pr_date) >='#{finayear}' AND DATE(pr_date) <='#{lastfinyear}'
  iswhere      += " AND pr_customer_id='#{customers}' AND pr_status<>'C'"
  receiveobj   = MstPaymentReceive.select(isselect).where(iswhere).group("pr_customer_id")
  return receiveobj
end

private
def get_export_recived_payment
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "sum(pli_net_amount) as totalAmount,cst.id as CstId,cs_customername,sum(pli_total_amount) as totalvalue"
  isselect +=  ",'' as totalReceive,'' as dueamount,pli_invoice_to_id as hd_customer_id,'' as pendingamnt"
  jons     =  "JOIN mst_customers cst ON(cst.id=pli_invoice_to_id AND cst.cs_compcode=pli_compcode)"
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_sale_type IN('S') AND pli_local_type='Export' AND pli_status<>'C'"
  # iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}'"
  saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere).group("pli_invoice_to_id")
  arr      = []
   if saleobj.length >0
         saleobj.each do |rcv|
              rcv.dueamount  = rcv.totalAmount.to_f
              recvobj = get_recived_amount(rcv.hd_customer_id)
              if recvobj.length >0
                rcv.pendingamnt = rcv.totalAmount.to_f-recvobj[0].totalPayReceive.to_f
                rcv.totalReceive = recvobj[0].totalPayReceive.to_f
              else
               rcv.pendingamnt = rcv.totalAmount.to_f
               rcv.totalReceive = 0
              end
              arr.push rcv
         end
         printcontrol =  "1_payment_report"
         @PayPrint    =  sale_insight_path(printcontrol,:format=>"pdf")

   end
  return arr
end


private
def get_monthly_total_outsatnding(month)
  totinv     = 0
  isselect   = "SUM(pli_balan_amount) as totalinvoice"
  totinvobj  =  TrnPackingInvoice.select(isselect).where("pli_compcode = ? AND DATE(NOW()) >=DATE(pli_due_date) AND MONTH(pli_date) = ? AND pli_status<>'C'",@compcodes,month).first
  if totinvobj
    totinv = totinvobj.totalinvoice
  end
  return totinv

end

private
def get_export_chart_month_wise
  searchdate   = params[:mysearchdated]
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  if searchdate!=nil && searchdate!=''
    finayear    = searchdate
    lastfinyear = searchdate.to_i+1
    @searchdate = searchdate
  end
  isselect =  "sum(pli_net_amount) as totalAmount,cst.id as CstId,cs_customername,sum(pli_total_amount) as totalvalue,MONTH(pli_date) as month"
  isselect +=  ",MONTH(pli_date) as months,'' as totalReceive,'' as dueamount,pli_invoice_to_id as hd_customer_id,'' as pendingamnt,'' as overdueamt,pli_sale_type as sale,'' as hd_paymentmode"
  jons     =  "JOIN mst_customers cst ON(cst.id=pli_invoice_to_id AND cst.cs_compcode=pli_compcode)"
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_sale_type IN('S') AND pli_local_type='Export' "
  iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}' AND pli_status<>'C'"
  saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere).group("MONTH(pli_date)")
  arr      = []
   if saleobj.length >0
         saleobj.each do |rcv|
              rcv.dueamount  = rcv.totalAmount.to_f
            #  recvobj  =  get_recived_amount(rcv.hd_customer_id)
              ovdueobl =  get_customer_overdue(rcv.hd_customer_id)
              #if recvobj.length >0
              #  rcv.pendingamnt = get_monthly_total_outsatnding(rcv.months)# rcv.totalAmount.to_f-recvobj[0].totalPayReceive.to_f
               
              #else
              # rcv.pendingamnt  = rcv.totalAmount.to_f
               #rcv.totalReceive = 0
              #end
               rcv.pendingamnt = get_monthly_total_outsatnding(rcv.months)
              if ovdueobl.length >0
                rcv.overdueamt = ovdueobl[0].totalAmount
              end
              arr.push rcv
         end
   end
  return arr
end

private
def get_export_customer_overdue(customers)
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  " sum(pli_total_amount) as totalAmount,cst.id as cstId"
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_sale_type IN('S') AND DATE(CURRENT_DATE()) > DATE_ADD(pli_date,INTERVAL cs_creditdays DAY)"
 # iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}' "
  iswhere  += " AND pli_invoice_to_id='#{customers}' AND cs_creditdays >0 AND pli_local_type='Export' AND pli_status<>'C'"
  jons     =  "JOIN mst_customers cst ON(cst.id=pli_invoice_to_id AND cst.cs_compcode=pli_compcode)"
  saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere).group("MONTH(pli_date)")
  return saleobj

end

private
def average_monthly_export_sale
  monthlysale  = 0
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date  
  
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_status<>'C'"
  iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}' AND pli_local_type='Export' AND pli_status<>'C'"
  isselect  = " COALESCE(sum(pli_net_amount),0) as totalsale,MONTH(pli_date) as month,pli_sale_type as sale"
  avrgmon   = TrnPackingInvoice.select(isselect).where(iswhere).first
  if avrgmon
   
    monthlysale = avrgmon.totalsale
  end
  tmonth = count_monthly_financial()
  if monthlysale.to_f >0
     monthlysale = monthlysale.to_f/tmonth.to_i
  end
 return monthlysale

end

private
def count_monthly_financial   
    finayear     = financial_session_date
    lastfinyear  = last_financial_session_date

    iswhere  =  " pli_compcode='#{@compcodes}' AND pli_status<>'C'"
    iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}' AND pli_local_type = 'Export' "
    isselect  = " COUNT(MONTH(pli_date)) as month"
    avrgmon   = TrnPackingInvoice.select(isselect).group("MONTH(pli_date)").where(iswhere)
    mth       = 0
    if avrgmon.length >0
      avrgmon.each do |avrgmons|
        mth +=1
      end
    end
 return mth

end

private
def export_maximum_revenue_charts
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  gxorders     = " (CASE
                WHEN pli_sale_type ='SL' THEN 'S'
                WHEN pli_sale_type ='SO' THEN 'S'
                WHEN pli_sale_type ='SO' THEN 'S'
                ELSE pli_sale_type
                END),MONTH(pli_date)"
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_status<>'C'"
  # iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}' AND pli_local_type='Export'"
  isselect = " COALESCE(sum(pli_net_amount),0) as totalsale,MONTH(pli_date) as month,pli_sale_type as sale"
  tcharts  = TrnPackingInvoice.select(isselect).where(iswhere).group(gxorders).order("pli_net_amount DESC").first
 return tcharts

end
private
def export_print_customers_received_detail
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "sum(pli_net_amount) as totalAmount,cst.id as CstId,cs_customername,sum(pli_total_amount) as totalvalue"
  isselect +=  ",'' as lastdate,'' as totaldueamt,pli_invoice_to_id as hd_customer_id,'' as hd_paymentmode,'' as overdueamt"
  jons     =  "JOIN mst_customers cst ON(cst.id=pli_invoice_to_id AND cst.cs_compcode=pli_compcode)"
  iswhere  =  " pli_compcode='#{@compcodes}'  AND pli_sale_type IN('S') AND pli_local_type='Export' AND pli_status<>'C'"
 # iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}'"
  saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere).group("pli_invoice_to_id")
  return saleobj
end

private
def export_print_recived_payment
  finayear     = financial_session_date
  lastfinyear  = last_financial_session_date
  isselect =  "sum(pli_net_amount) as totalAmount,cst.id as CstId,cs_customername,sum(pli_total_amount) as totalvalue"
  isselect +=  ",'0' as totalReceive,'' as dueamount,pli_invoice_to_id as hd_customer_id,'' as pendingamnt,'' as hd_paymentmode"
  jons     =  "JOIN mst_customers cst ON(cst.id=pli_invoice_to_id AND cst.cs_compcode=pli_compcode)"
  iswhere  =  " pli_compcode='#{@compcodes}' AND pli_sale_type IN('S') AND pli_local_type='Export' AND pli_status<>'C'"
 # iswhere  += " AND DATE(pli_date) >= '#{finayear}' AND DATE(pli_date) <= '#{lastfinyear}'"
  saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere).group("pli_invoice_to_id")
  return saleobj
end

private
def as_on_duedays_total
 
 
  month_number =  Time.now.month
  month_begin  =  Date.new(Date.today.year, month_number)
  begdate      =  Date.parse(month_begin.to_s)
  cdates       =  begdate.strftime('%Y-%m-%d')
  

  isselect =  "'' as totalAmount,cst.id as CstId,cs_customername,cs_emailaddress,'' as totalvalue,'' as duepends "
  isselect +=  ",pli_due_date,'' as lastdate,'' as totaldueamt,pli_invoice_to_id as hd_customer_id,'' as totalInvoice"
  jons     =  " LEFT JOIN mst_customers cst ON(cst.id = pli_invoice_to_id AND cst.cs_compcode = pli_compcode)"
  iswhere  =  " pli_compcode = '#{@compcodes}' AND pli_sale_type IN('S') AND pli_local_type = 'Export' AND pli_status<>'C'"
  #iswhere  += " AND DATE(pli_due_date) < '#{cdates}' AND pli_due_date<>'' "
  #iswhere    += " AND (CASE WHEN pli_due_date<>'0000-00-00' THEN DATE(pli_due_date) ELSE DATE(pli_date) END )< '#{cdates}'"
  
  
   saleobj  =  TrnPackingInvoice.select(isselect).joins(jons).where(iswhere).group("pli_invoice_to_id").having("SUM(pli_balan_amount) >0")
   arr      = []
   if saleobj.length >0
         saleobj.each do |rcv|              
              dueamt          = new_asonmonth_customerwise_totaloutsatnding(rcv.hd_customer_id,cdates)
              rcv.totaldueamt = dueamt
              arr.push rcv
         end

   end
  return arr
  
end



###### END EXPORT INVOICE CALCULATION########

end
